<?php

  /* ****************************************** *
   *                                            *
   * (c)2003 by Jan Krupa (krupaj@mobilnews.cz) *
   * http://www.mobilnews.cz/honza/             *
   *                                            *
   * ****************************************** */

  Header("Content-type: image/png");

  function returnState($state_file, $state_ip) {
  // Return computer state

    $file_in = fopen($state_file, "r");
      if (!$file_in) { exit; }

    while (!feof($file_in)) {
      $fin_line=fgets($file_in, 1024);
      
        $fl_ip = strtok($fin_line, ";");
        $fl_state = strtok(";");
	$fl_lat   = strtok(";");

        if ($fl_ip == $state_ip) {
          fclose($file_in);
	  if ($fl_state > 0 ) {
	    return "1;" . $fl_lat . ";";
	  }
          return "0;0;";
        }
    }

    fclose($file_in);

    return 2;
  }

  function placeAP ($im, $x1, $y1, $ap_name, $ap_ip, $ap_type, $ap_state, $ap_lat) {
  // Place AP (computer) on the map

    $ap_xsize=100;
    $ap_ysize=35;
    $ap_name_size=ImageFontWidth(3)*strlen($ap_name);
    $ap_ip_size=ImageFontWidth(2)*strlen($ap_ip);
    $ap_lat_size=ImageFontWidth(2)*strlen(round($ap_lat))+6;
    if ($ap_lat == 0) { $ap_lat_size=1; }

    if (($ap_name_size+$ap_lat_size+10) > ($ap_xsize)) {
      $ap_xsize=$ap_name_size+$ap_lat_size+10;
      /*
      if (($ap_ip_size+10) > $ap_xsize) {
        $ap_xsize=$ap_ip_size+10;
      }
      */
    }

    switch ($ap_state) {
      case 0 : $ap_color=ImageColorExact($im, 255, 0, 0); $ap_color2=ImageColorExact($im, 255, 140, 140); break;
      case 1 : $ap_color=ImageColorExact($im, 0, 255, 0); $ap_color2=ImageColorExact($im, 140, 255, 140); break;
      case 2 : $ap_color=ImageColorExact($im, 140, 140, 140); $ap_color=ImageColorExact($im, 220, 220, 220); break;
    }

    ImageRectangle($im, ($x1-($ap_xsize/2)), ($y1-($ap_ysize/2)), ($x1+($ap_xsize/2)), ($y1+($ap_ysize/2)), ImageColorExact($im, 0, 0, 0));
    ImageFilledRectangle($im, ($x1-($ap_xsize/2-1)), ($y1-($ap_ysize/2-1)), ($x1+($ap_xsize/2-$ap_lat_size)), ($y1-($ap_ysize/2-15)), $ap_color);
    ImageLine($im, ($x1-($ap_xsize/2-1)), ($y1-($ap_ysize/2-16)), ($x1+($ap_xsize/2-1)), ($y1-($ap_ysize/2-16)), ImageColorExact($im, 140, 140, 140));

    if ($ap_lat !=0 ) {
      ImageFilledRectangle($im, ($x1+($ap_xsize/2-$ap_lat_size+2)), ($y1-($ap_ysize/2-1)), ($x1+($ap_xsize/2-1)), ($y1-($ap_ysize/2-15)), $ap_color2);
      ImageLine($im, ($x1+($ap_xsize/2-$ap_lat_size+1)), ($y1-($ap_ysize/2-1)), ($x1+($ap_xsize/2-$ap_lat_size+1)), ($y1-($ap_ysize/2-15)),ImageColorExact($im, 140, 140, 140));
      ImageString($im, 2, ($x1+($ap_xsize/2)-$ap_lat_size+4), $y1-($ap_ysize/2-2), round($ap_lat), ImageColorExact($im, 0, 0, 0));
    }

    ImageFilledRectangle($im, ($x1-($ap_xsize/2-1)), ($y1-($ap_ysize/2-17)), ($x1+($ap_xsize/2-1)), ($y1+($ap_ysize/2-1)), ImageColorExact($im, 220, 220, 220));

    for ($i=1; $i<=$ap_type; $i++) {
      ImageRectangle($im, ($x1-($ap_xsize/2)-$i), ($y1-($ap_ysize/2)-$i), ($x1+($ap_xsize/2)+$i), ($y1+($ap_ysize/2)+$i), ImageColorExact($im, 0, 0, 0));
    }

    ImageString($im, 3, ($x1-($ap_name_size/2)-($ap_lat_size/2)+2), $y1-($ap_ysize/2-2), $ap_name, ImageColorExact($im, 0, 0, 0));
    ImageString($im, 2, ($x1-strlen($ap_ip)*3), $y1, $ap_ip, ImageColorExact($im, 0, 0, 0));

  }

  function placeLN ($im, $x1, $y1, $x2, $y2, $ln_type, $ln_state) {
  // Place link on the map

    $ln_type2=$ln_type;
    $ln_color2=0;

    while ($ln_type2 > 9) {
      $ln_color2++;
      $ln_type2-=10;
    }

    /*
    switch ($ln_state) {
      case 0 : $ln_color=ImageColorExact($im, 255, 0, 0); break;
      case 1 : $ln_color=ImageColorExact($im, 0, 255, 0); break;
      case 2 : $ln_color=ImageColorExact($im, 140, 140, 140); break;
    }
    */
    
    $ln_color=ImageColorExact($im, 180, 180, 180);
    switch ($ln_color2) {
      case 1 : $ln_color=ImageColorExact($im,   0,   0,   0); break;
      case 2 : $ln_color=ImageColorExact($im, 180,   0,   0); break;
      case 3 : $ln_color=ImageColorExact($im,   0, 180,   0); break;
      case 4 : $ln_color=ImageColorExact($im,   0,   0, 180); break;
      case 5 : $ln_color=ImageColorExact($im, 255,   0,   0); break;
      case 6 : $ln_color=ImageColorExact($im,   0, 255,   0); break;
      case 7 : $ln_color=ImageColorExact($im,   0,   0, 255); break;
    }

    ImageLine($im, $x1, $y1, $x2, $y2, $ln_color);

    for ($i=1; $i<=$ln_type2; $i++) {
      ImageLine($im, ($x1-$i), $y1, ($x2-$i), $y2, $ln_color);
      ImageLine($im, ($x1+$i), $y1, ($x2+$i), $y2, $ln_color);
      ImageLine($im, $x1, ($y1-$i), $x2, ($y2-$i), $ln_color);
      ImageLine($im, $x1, ($y1+$i), $x2, ($y2+$i), $ln_color);
    }

  }

  // --- Read configuration - begin ------------------------------------------
  $calstats_version = "0.0.8";
  $calstats_id = "CaLStats";
  $image_filename = $argv[1];
  $image_date_lu = "Last update ";

  $a_date = getdate();
    $a_date_minutes = $a_date['minutes']; if ($a_date_minutes < 10) { $a_date_minutes = "0" . $a_date_minutes; }
    $a_date_seconds = $a_date['seconds']; if ($a_date_seconds < 10) { $a_date_seconds = "0" . $a_date_seconds; }
    $image_date =  $image_date_lu . $a_date['mday'] . " " . $a_date['month'] . " " . $a_date['year'] . " "
                . $a_date['hours'] . ":" . $a_date_minutes . ":" . $a_date_seconds;

  $file_in = fopen($image_filename . ".config", "r");
    if (!$file_in) { exit; }

  $fin_line=fgets($file_in, 1024);
    $image_title = strtok($fin_line, ";");
    $image_xsize = strtok(";");
    $image_ysize = strtok(";");

  fclose($file_in);
  // --- Read configuration - end --------------------------------------------


  $im = imagecreate($image_xsize, $image_ysize);

  $im_white  = ImageColorAllocate($im, 255, 255, 255);
  $im_black  = ImageColorAllocate($im,   0,   0,   0);
  $im_gray1  = ImageColorAllocate($im, 140, 140, 140);
  $im_gray2  = ImageColorAllocate($im, 180, 180, 180);
  $im_gray3  = ImageColorAllocate($im, 200, 200, 200);
  $im_gray4  = ImageColorAllocate($im, 220, 220, 220);
  $im_gray5  = ImageColorAllocate($im, 240, 240, 240);
  $im_red    = ImageColorAllocate($im, 255,   0,   0);
  $im_green  = ImageColorAllocate($im,   0, 255,   0);
  $im_blue   = ImageColorAllocate($im,   0,   0, 255);
  $im_red2   = ImageColorAllocate($im, 180,   0,   0);
  $im_green2 = ImageColorAllocate($im,   0, 180,   0);
  $im_blue2  = ImageColorAllocate($im,   0,   0, 180);
  $im_red3   = ImageColorAllocate($im, 255, 140, 140);
  $im_green3 = ImageColorAllocate($im, 140, 255, 140);
  $im_blue3  = ImageColorAllocate($im, 140, 140, 255);

  ImageRectangle($im, 0, 0, ($image_xsize-1), ($image_ysize-1), $im_black);
  ImageFilledRectangle($im, 1, 1, ($image_xsize-2), 15, $im_black);
  ImageString($im, 3, 5, 1, $image_title, $im_white);
  ImageString($im, 2, ($image_xsize-ImageFontWidth(2)*strlen($image_date)-5), 1, $image_date, $im_gray4);

  ImageStringUp($im, 1, ($image_xsize-10), ($image_ysize-5), $calstats_id . " " . $calstats_version, $im_gray2);

  // --- Draw links - begin --------------------------------------------------
  $file_in = fopen($image_filename . ".link", "r");
    if (!$file_in) { exit; }

  $fin_line=fgets($file_in, 1024);
    $fl_type = strtok($fin_line, ";");
    $fl_name1 = strtok(";");
    $fl_num = 2;

  while (!feof($file_in)) {
    $fl_type = strtok($fin_line, ";");
    for ($fl_tmp1=0; $fl_tmp1 < $fl_num; $fl_tmp1++) {
      $fl_name2 = strtok(";");
    }
    
    if ($fl_name2 == "") {
      $fin_line=fgets($file_in, 1024);
        $fl_type = strtok($fin_line, ";");
        $fl_name1 = strtok(";");
        $fl_name2 = strtok(";");
	$fl_num = 2;
    }

    $file_in2 = fopen($image_filename . ".comp", "r");
      if (!$file_in2) { exit; }

    while (!feof($file_in2)) {
      $fin2_line=fgets($file_in2, 1024);
        $fl2_name = strtok($fin2_line, ";");
        $fl2_ip   = strtok(";");
        $fl2_type = strtok(";");
        $fl2_x1   = strtok(";");
        $fl2_y1   = strtok(";");

        if ($fl2_name != "") {
          if ($fl2_name == $fl_name1) { $fl_x1 = $fl2_x1; $fl_y1 = $fl2_y1; };
	  if ($fl2_ip   == $fl_name1) { $fl_x1 = $fl2_x1; $fl_y1 = $fl2_y1; };
          
	  if ($fl2_name == $fl_name2) { $fl_x2 = $fl2_x1; $fl_y2 = $fl2_y1; };
	  if ($fl2_ip   == $fl_name2) { $fl_x2 = $fl2_x1; $fl_y2 = $fl2_y1; };
        }
    }

    fclose($file_in2);

    if ($fl_x1 != 0) {
      placeLN($im, $fl_x1, $fl_y1, $fl_x2, $fl_y2, $fl_type, 2);
    }
    
    $fl_name1 = $fl_name2;
    $fl_num++;

  }

  fclose($file_in);
  // --- Draw links - end ----------------------------------------------------

  // --- Draw computers - begin ----------------------------------------------
  $file_in = fopen($image_filename . ".comp", "r");
    if (!$file_in) { exit; }

  while (!feof($file_in)) {
    $fin_line=fgets($file_in, 1024);
      $fl_name = strtok($fin_line, ";");
      $fl_ip   = strtok(";");
      $fl_type = strtok(";");
      $fl_x1   = strtok(";");
      $fl_y1   = strtok(";");

    $fl_state_tmp = returnState($image_filename . ".state", $fl_ip);
    $fl_state = strtok($fl_state_tmp, ";");
    $fl_lat = strtok(";");

      if ($fl_name != "") {
        placeAP($im, $fl_x1, $fl_y1, $fl_name, $fl_ip, $fl_type, $fl_state, $fl_lat);
      }
  }

  fclose($file_in);
  // --- Draw computers - end ------------------------------------------------


  // --- Draw legend - begin -------------------------------------------------
  if (file_exists($image_filename . ".legend")) {
    $file_in = fopen($image_filename . ".legend", "r");
      if (!$file_in) { exit; }

    $l_num=0;
    $l_num_string=0;
    while (!feof($file_in)) {
      $fin_line=fgets($file_in, 1024);
        $fl_ltype = strtok($fin_line, ";");
        $fl_lname = strtok(";");

        if ($fl_ltype != "") {
          $l_num++;
	  if (strlen($fl_lname)>$l_num_string) {
	    $l_num_string=strlen($fl_lname);
	  }
        }
    }

    fclose($file_in);

    $l_xloc=10;
    $l_yloc=($image_ysize-10-($l_num*15));

    ImageRectangle($im, $l_xloc, ($l_yloc-2), ($l_xloc+25+($l_num_string*6)), $image_ysize-10, ImageColorExact($im, 200, 200, 200));
    ImageFilledRectangle($im, ($l_xloc+1), ($l_yloc-1), ($l_xloc+24+($l_num_string*6)), ($image_ysize-11), ImageColorExact($im, 240, 240, 240));

    $file_in = fopen($image_filename . ".legend", "r");
      if (!$file_in) { exit; }

    while (!feof($file_in)) {
      $fin_line=fgets($file_in, 1024);
        $fl_ltype = strtok($fin_line, ";");
        $fl_lname = strtok(";");

        if ($fl_ltype != "") {
          placeLN($im, ($l_xloc+5), ($l_yloc+7), ($l_xloc+15), ($l_yloc+7), $fl_ltype, 2);
	  ImageString($im, 2, ($l_xloc+20), ($l_yloc), $fl_lname, ImageColorExact($im, 0, 0, 0));
	  $l_yloc+=15;
        }
    }

    fclose($file_in);
  }
  // --- Draw legend - end ---------------------------------------------------

  ImagePng ($im);
  ImageDestroy($im);

?>
